#include <stdlib.h>
#include <stdio.h>
#include <math.h>

#define VAR 131072
#define W 352
#define H 288
#define FRAMES 30

static long long  x=0x1234ABCD330E;

/*
  \note Output is an uniformly distributed random variable [0,1].
*/
double drand48()
{
    x = x*0x5DEECE66D + 0xB;
    return (x&0xFFFFFFFFFFFF)*(1.0/281474976710656.0);
}

/*
  \note Output is a gaussian random variable N(0,1).
*/
double nrnd (double var)
{
  static int sw = 0;
  static double r1, r2, s;

  if (sw == 0) {
    sw = 1;
    do {
      r1 = 2 * drand48() - 1;
      r2 = 2 * drand48() - 1;
      s = r1 * r1 + r2 * r2;
    } while (s > 1 || s == 0);
    s = sqrt(-2 * log(s) / s);
    return r1 * s * sqrt(var);
  } else {
    sw = 0;
    return r2 * s * sqrt(var);
  }
}

void main(int argc, char **argv)
{
  FILE *fp;
  int f;
  int x, y, uv;
  int i;
  unsigned char p;

  if((fp = fopen(argv[1], "wb")) == NULL)
  {
    printf("Error! Can not open %s\n", argv[1]);
    exit(-1);
  }

  for (f = 0; f < FRAMES; f++)
  {
    // Y
    for (y = 0; y < H; y++)
    {
      for (x = 0; x < W; x++)
      {				
        i = (int) floor(128 + nrnd (VAR) + 0.4999999999);
        p = (i > 255)? (255):(i < 0)?(0):(i);
        fwrite(&p,1,1,fp);
      }
    }

    // UV
    for(uv = 0; uv < 2; uv++)
    {
      for (y = 0; y < H/2; y++)
      {
        for (x = 0; x < W/2; x++)
        {				
          i = (int) floor(128 + nrnd (VAR) + 0.4999999999);
          p = (i > 255)? (255):(i < 0)?(0):(i);
          fwrite(&p,1,1,fp);
        }
      }
    }
  }

  fclose(fp);
}